<?php
/*
2010-02-27: Memberpages 2.1 XH
- code-cleaning of all php-files
- New function memberswarning() - warning if a member is logged in (usable in template)
- no more special files necessary for logged_out, logged_in, login_error and Members_not_logged_in, memberpages causes some messages now.
- settings for login_page, logout_page and error_page moved to the language files, for better functionality in multilingual sites 
 
2009: Memberpages 2.0 XH - rewrote code for CMSimple_XH
- (X)html valid output

==============================================
History up to 2007
==============================================
CMSimple members plugin version 1.7
- Fix for URL first level of path missing when using hide_pages=true
CMSimple members plugin version 1.6
- Solving a problem in IIS with the use of header function
CMSimple members plugin version 1.5
- $sn and $su missing in form action in function memberspage() and memberslogin()
CMSimple members plugin version 1.4
- minor bug fix for cache in Mozilla browsers, added hide pages in toc and sitemap
CMSimple members plugin version 1.3
- minor bug fix, csv_seperator made configurable
CMSimple members plugin version 1.2
- minor bug fix, faulty setting of session['page'], causing problems with advanced news script
CMSimple members plugin version 1.1
- minor bug fix, for fixing problem with quot instead of "
- some language files added, lv,se,fi thanks to triumaz and martinm
CMSimple members plugin version 1.0
- New feature added : Pages can be hidden from TOC
- sv('REQUEST_URI') changed $sn
CMSimple members plugin version 0.6
- New feature added : Remember me function using cookie, and logging function and loading of members from external csv file
CMSimple members plugin version 0.5
- New feature added : Now it's possible to have multiple accessclasses on a page
CMSimple members plugin version 0.4
- Error message when headers already sent by other PHP file.
- sv('REQUEST_URI') changed to support IIS
CMSimple members plugin version 0.3
- Adapted to the plugin loader plugin
CMSimple members plugin version 0.2
- logout bug when using multiple language installation of CMSimple fixed
CMSimple members plugin version 0.1 beta 3
- parameters moved to config.php
- access level added
CMSimple members plugin version 0.1 beta 2
- initvar added when running php in safemode
CMSimple members plugin version 0.1 beta 1
- the first draft
*/

if (!function_exists('sv') || (strlen($sl) !== 2)) die('Access denied'); //HI prevent direct access

if (eregi("Googlebot",$_SERVER[HTTP_USER_AGENT]));
else if (eregi("MSNbot",$_SERVER[HTTP_USER_AGENT]));
else if (eregi("slurp",$_SERVER[HTTP_USER_AGENT]));
else session_start();
@header("Cache-Control: no-cache, must-revalidate");
$plugin=basename(dirname(__FILE__),"/");
$secret_word = "cmsimpleplugins";

if (!isset($sl))$sl=$cf['language']['default'];
$pth['file']['plugins_language']=$pth['folder']['plugins'].$plugin.'/languages/'.$sl.'.php';
$pth['file']['plugins_config']=$pth['folder']['plugins'].$plugin.'/config/config.php';
$pth['file']['plugins_config_advanced']=$pth['folder']['plugins'].$plugin.'/config/config_advanced.php';

if(!@include($pth['file']['plugins_language']))die('Plugin Language file '.$pth['file']['plugins_language'].' missing');
if(!@include($pth['file']['plugins_config']))die('Plugin config file '.$pth['file']['plugins_config'].' missing');
if(!@include($pth['file']['plugins_config_advanced']))die('Plugin advanced config file '.$pth['file']['plugins_config_advanced'].' missing');

$plugin_cf['memberpages']['login_page']=$plugin_tx['memberpages']['page_login'];
$plugin_cf['memberpages']['logout_page']=$plugin_tx['memberpages']['page_logout'];
$plugin_cf['memberpages']['error_page']=$plugin_tx['memberpages']['page_error'];

if(!($edit&&$adm))
{
	if(eregi("true",$plugin_cf['memberpages']['hide_pages']))
	{
		for($i = 0; $i < $cl; $i++) 
		{
			if(preg_match("/".$cf['scripting']['regexp']."/is",$c[$i]))
			{
				$plugindata = preg_replace(array("'&(quot|#34);'i","'&(apos|#39);'i","'\"'i"),array("'","'","'"),$c[$i]);
				if (strpos($plugindata, 'memberspage(') !== false)
				{
					$data = strip_tags(stristr($plugindata, "memberspage("));
					list($data, $crap) = explode(");", $data);
					list($page, $access_level) = explode("','", $data);
					unset($_SESSION['page']);
					$access_level = ereg_replace("[\"']", "", $access_level);
					$access_levels = explode(",", $access_level);
					if(array_search($_SESSION['accesslevel'],$access_levels)=== false)
					{
						$c[$i] = '#CMSimple hide#';
					}
				}
			}
		}
	}
}

$user_array = explode(",", $plugin_cf[$plugin]['user_array']);
$pass_array = explode(",", $plugin_cf[$plugin]['pass_array']);
$accesslevel_array = explode(",", $plugin_cf[$plugin]['accesslevel_array']);

if(is_file($plugin_cf['memberpages']['csvfile']))
{
	$fp = fopen($plugin_cf['memberpages']['csvfile'], "r");
	while (!feof($fp)) 
	{
		$line = fgets($fp, 4096);
		list($member_name,$member_pass,$member_accesslevel) = split( "[".$plugin_cf[$plugin]['csv_seperator']."]", $line);
		array_push($user_array, trim($member_name));
		array_push($pass_array, trim($member_pass));
		array_push($accesslevel_array, trim($member_accesslevel));
	}
}
fclose($fp);

if(eregi("true",$plugin_cf['memberpages']['rememberme']))
{
	if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
	{
		if(!isset($_SESSION['Name']) && !isset($_SESSION['sessionnr']))$function='memberslogin';
	}
}
if($function=='memberslogin')$f='memberslogin';
if($function=='memberslogout')$f='memberslogout';

function se($s)
{
	global $_SESSION; // if phpversion() above 4.1 you might want to use $_SESSION $HTTP_SESSION_VARS
	if(isset($_SESSION[$s]))return $_SESSION[$s];else return'';
}

//LOGIN
if($f=='memberslogin')
{
	initvar('username');
	initvar('password');
	if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
	{
		$username = $_COOKIE['cookname'];
		$password_hash = $_COOKIE['cookpass'];
	}
	else
	{
	$password_hash=md5($secret_word.$password);
	}
	$user_length = count($user_array);for($i=0;$i<$user_length;$i++)
	{
		if($username == $user_array[$i] && $password_hash == md5($secret_word.$pass_array[$i]))
		{
			if(isset($_POST['remember']))
			{
				$password_hash = md5($secret_word.$password);
				setcookie("cookname", $username, time()+60*60*24*100, "/");
				setcookie("cookpass", $password_hash, time()+60*60*24*100, "/");
			}
			$_SESSION['sessionnr'] = session_id();
			$_SESSION['accesslevel'] = $accesslevel_array[$i];
			$_SESSION['Name'] = $username;
			if(eregi("true",$plugin_cf['memberpages']['logfile']))
			{
				$logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
				fwrite($logfile, "$username logged in ".date("Y-m-d H:i:s")."\n");
			}
				
//If a login_page is defined use it
			if($plugin_cf['memberpages']['login_page'])
			{
				header('Location: '.$sn.'?'.$plugin_cf['memberpages']['login_page']);
				exit;
			}
				
//else just update where you came from
			if(!$plugin_cf['memberpages']['login_page']&&$pth['folder']['base']=='./')
			{
				header('Location: ..'.$sn.'?'.$su);
				exit;
			}
			if(!$plugin_cf['memberpages']['login_page']&&$pth['folder']['base']=='./../')
			{
				header('Location: ../..'.$sn.'?'.$su);
				exit;
			}
		}
	}

	if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
	{
		setcookie("cookname", "", time()-60*60*24*100, "/");
		setcookie("cookpass", "", time()-60*60*24*100, "/");
	}
	if(eregi("true",$plugin_cf['memberpages']['logfile']))
	{
		$logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
		fwrite($logfile, "$username wrong password ".date("Y-m-d H:i:s")."\n");
	}
		
//If a error_page is defined use it
	if($plugin_cf['memberpages']['error_page'])
	{
		header('Location: '.$sn.'?'.$plugin_cf['memberpages']['error_page']);
		exit;
	}
		
//else give an error message
	else
	{
		$o='<div class="mpp_message">'.$plugin_tx['memberpages']['login_error'].'</div>';
	}
}

//LOGOUT
if($f=='memberslogout')
{
	$_SESSION = array();
	session_destroy();
	if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
	{
		setcookie("cookname", "", time()-60*60*24*100, "/");
		setcookie("cookpass", "", time()-60*60*24*100, "/");
	}
	if(eregi("true",$plugin_cf['memberpages']['logfile']))
	{
		$logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
		fwrite($logfile, "$username logged out ".date("Y-m-d H:i:s")."\n");
	}
	
//If a logout_page is defined use it
	if($plugin_cf['memberpages']['logout_page'])
	{
		header('Location: '.$sn.'?'.$plugin_cf['memberpages']['logout_page']);
		exit;
	}
		
//else give a message
	else
	{
		$o='<div class="mpp_message">'.$plugin_tx['memberpages']['logged_out'].'</div>';
	}
}

//FUNCTIONS
function memberslogin()
{
	global $sn,$su,$plugin_cf,$plugin_tx,$tx;
	$plugin=basename(dirname(__FILE__),"/");
	if(!isset($_SESSION['Name'],$_SESSION['sessionnr'])|| se('sessionnr') != session_id()) 
	{
		$o = "\n".'<form action="'.$sn.'?'.$su.'" method="post">'."\n";
		$o.= tag('input type="hidden" name="function" value="memberslogin"')."\n";
		$o.= $plugin_tx[$plugin]['username'].tag('br')."\n";
		$o.= tag('input type="text" name="username" class="mpp_member"').tag('br')."\n";
		$o.= $plugin_tx[$plugin]['password'].tag('br')."\n";
		$o.= tag('input type="password" name="password" class="mpp_member"').tag('br')."\n";
		
		if(eregi("true",$plugin_cf['memberpages']['rememberme']))
		{
			$o.= tag('input type="checkbox" name="remember" class="mpp_member_checkbox"')."\n";
			$o.= $plugin_tx[$plugin]['remember_me'].tag('br')."\n";
		}
		$o.= tag('input type="submit" name="submit" class="mpp_member_button" value="'.$plugin_tx[$plugin]['login'].'"')."\n";
		$o.= '</form>'."\n"."\n";
	}
	else
	{
		$o = tag('br')."\n"."\n".'<span class="mpp_loginout">'.$plugin_tx[$plugin]['loggedin'].'</span>'."\n";
		$o.= '<form action="'.$sn.'?'.$su.'" method="post">'."\n";
		$o.= tag('input type="hidden" name="function" value="memberslogout"').tag('br')."\n";
		$o.= tag('input type="submit" class="mpp_member_button" value="'.$plugin_tx[$plugin]['logout'].'"')."\n";
		$o.= '</form>'."\n"."\n";
	}
	return $o;
}

function memberswarning()
{
	global $sn,$su,$plugin_cf,$plugin_tx,$tx;
	$plugin=basename(dirname(__FILE__),"/");
	if(!isset($_SESSION['Name'],$_SESSION['sessionnr'])|| se('sessionnr') != session_id()) 
	{
		$o = '';
	}
	else
	{
		$o = "\n".'<form action="'.$sn.'?'.$su.'" method="post">'."\n";
		$o.= '<div class="mpp_loggedin_warning">'."\n";
		$o.= $plugin_tx[$plugin]['loggedin'].tag('br')."\n";
		$o.= tag('input type="hidden" name="function" value="memberslogout"')."\n";
		$o.= tag('input type="submit" class="mpp_member_button" value="'.$plugin_tx[$plugin]['logout'].'"')."\n";
		$o.= '</form>'."\n".'</div>'."\n"."\n";
	}
	return $o;
}

function memberspage($error_page,$level)
{
	global $sn,$su,$plugin_cf,$plugin_tx,$tx,$o;
	if(headers_sent($filename,$linenum))
	{
		echo "ERROR : memberpages detected that someone already had sent headers, look for the error in $filename line $linenum";
		exit;
	}
	$access = explode(",", $level);
	if(!isset($_SESSION['Name'],$_SESSION['sessionnr'],$_SESSION['accesslevel'])|| se('sessionnr') != session_id() || (!in_array(se('accesslevel'), $access)))
	{
		header('Location: '.$sn.'?'.$error_page);
		exit;
	}
}
?>